//
//  OffcnIMSDKiOS.m
//  OffcnIMSDKiOS
//
//  Created by vockey on 2018/10/16.
//  Copyright © 2018年 中公教育. All rights reserved.
//

#import "OffcnIMSDKiOS.h"
#import "OffcnBaseNetworking.h"
#import "ZYJRealReachability.h"
#import "SDGeneralDefine.h"
#import "OffcnNetworkExecutor.h"
#import "OffcnUploadManager.h"
#import "SDGeneralTool.h"
#import "DataSafe.h"
#import "NSString+MD5.h"

@interface OffcnIMSDKiOS ()


@end

@implementation OffcnIMSDKiOS

static OffcnIMSDKiOS *liveTelecastSDK;
+ (OffcnIMSDKiOS *)defaultService{
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        liveTelecastSDK = [[OffcnIMSDKiOS alloc] init];
    });
    return liveTelecastSDK;
}
-(instancetype)init{
    self = [super init];
    if (self) {
        
    }
    return self;
}
-(void)setIsTest:(BOOL)isTest{
    if (isTest) {
        [[OffcnBaseNetworking sharedInstance] setServiceType:2];
    }else{
        [[OffcnBaseNetworking sharedInstance] setServiceType:3];
    }
    _isTest = isTest;
}

#pragma mark - 使用RealReachability监听网络状态
-(void)startNotifierUseRealReachability{
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(networkChanged:)                                            name:ZYJkRealReachabilityChangedNotification object:nil];
    
    GLobalRealReachability.hostForPing = @"api.live.offcncloud.com";
    GLobalRealReachability.pingTimeout = 10;
    [GLobalRealReachability startNotifier];
    
    ReachabilityStatus status = [GLobalRealReachability currentReachabilityStatus];
    [self realNetworkingStatus:status];
}
- (void)networkChanged:(NSNotification *)notification
{
    ZYJRealReachability *reachability= (ZYJRealReachability *)notification.object;
    ReachabilityStatus status= [reachability currentReachabilityStatus];
    [self realNetworkingStatus:status];
}
-(void)realNetworkingStatus:(ReachabilityStatus)status{
    KWeakSelf
    switch (status){
        case RealStatusUnknown:
        case RealStatusNotReachable:
        {
            [OffcnNetworkExecutor requesImgJsonWithUrlStr:@"https://api.live.offcncloud.com" Finished:^(BOOL success, id response, NSString *message) {
                if (success) {
                    weakSelf.OffcnReachabilityStatus = OffcnSDKReachabilityStatusViaWiFi;
                    if (weakSelf.reachabilityStatusCallBack) {
                        weakSelf.reachabilityStatusCallBack(OffcnSDKReachabilityStatusViaWiFi);
                    }
                }else{
                    weakSelf.OffcnReachabilityStatus = OffcnSDKReachabilityStatusNotReachable;
                    if (weakSelf.reachabilityStatusCallBack) {
                        weakSelf.reachabilityStatusCallBack(OffcnSDKReachabilityStatusNotReachable);
                    }
                }
            }];
            break;
        }
        case RealStatusViaWWAN:
        {
            self.OffcnReachabilityStatus = OffcnSDKReachabilityStatusViaWWAN;
            if (self.reachabilityStatusCallBack) {
                self.reachabilityStatusCallBack(OffcnSDKReachabilityStatusViaWWAN);
            }
            break;
        }
        case RealStatusViaWiFi:
        {
            self.OffcnReachabilityStatus = OffcnSDKReachabilityStatusViaWiFi;
            if (self.reachabilityStatusCallBack) {
                self.reachabilityStatusCallBack(OffcnSDKReachabilityStatusViaWiFi);
            }
            break;
        }
        default:
            break;
    }
}

#pragma mark - 操作事件
-(void)sendMsgWithMsg_fromID:(NSString *)msg_fromID msg_toID:(NSString *)msg_toID msg_type:(OffcnSDKMsgType)msg_type text:(NSString *)text filePath:(NSString *)filePath Finished:(void(^)(BOOL success,id response,NSString *errorMessage))finished{
    
    //发送消息
    if (msg_type == OffcnSDKMsgTypeText) {
        if (!text || !text.length) {
            text = @"";
        }
        NSMutableDictionary *dataDic = [NSMutableDictionary dictionaryWithObject:text forKey:@"msg"];
        [OffcnNetworkExecutor requestSendMsgWithMsg_fromID:msg_fromID msg_toID:msg_toID msg_type:msg_type msg:dataDic Finished:^(BOOL success, id response, BaseResponse *baseResponse) {
    //        {
    //            "msg_id" = "6a4b71b9-e372-11ea-88a4-4a5555fb6ab4";
    //        }
            finished(success,nil,baseResponse.errorMessage);
        }];
    }else{
        if (!filePath || !filePath.length) {
            filePath = @"";
        }
        [[OffcnUploadManager defaultService] uploadToQNFilePath:filePath Finished:^(BOOL success, id  _Nonnull response, NSString * _Nonnull errorMessage) {
            if (success) {
                NSString *urlStr = @"";
                if (response) {
                    urlStr = [NSString stringWithFormat:@"%@",response];
                }
                NSMutableDictionary *dataDic = [NSMutableDictionary dictionary];
                
                if (msg_type == OffcnSDKMsgTypePicture) {
                    NSString *nameStr = [NSString stringWithFormat:@"%@%@",msg_toID,[SDGeneralTool getNowSSSTimeTimestamp]];
                    NSString *md5Str = [urlStr md5Encrypt];
                    
                    
                    [dataDic setObjectOnSafe:urlStr forKey:@"url"];
                    [dataDic setObjectOnSafe:nameStr forKey:@"name"];
                    [dataDic setObjectOnSafe:md5Str forKey:@"md5"];
                    [dataDic setObjectOnSafe:@"" forKey:@"thumb_url"];
                    
                    [dataDic setObjectOnSafe:@"" forKey:@"ext"];
                    [dataDic setObjectOnSafe:@"" forKey:@"w"];
                    [dataDic setObjectOnSafe:@"" forKey:@"h"];
                    [dataDic setObjectOnSafe:@"" forKey:@"size"];
                    
                    
                }else if (msg_type == OffcnSDKMsgTypeAudio){
                    
                }else if (msg_type == OffcnSDKMsgTypeVideo){
                    
                }else if (msg_type == OffcnSDKMsgTypeFile){
                    
                }
                
                
                [OffcnNetworkExecutor requestSendMsgWithMsg_fromID:msg_fromID msg_toID:msg_toID msg_type:msg_type msg:dataDic Finished:^(BOOL success, id response, BaseResponse *baseResponse) {
                    
                    finished(success,nil,baseResponse.errorMessage);
                }];
            }else{
                finished(success,nil,errorMessage);
            }
        }];
    }
}



-(void)dealloc{

}

@end
